;; @(#) $Id: gwyddion.iss.in,v 1.2.2.1 2005/04/04 18:45:10 yeti-dn Exp $
[Setup]
AppName=Gwyddion
AppVersion=1.12
AppVerName=Gwyddion 1.12
AppPublisher=Trific soft.
AppPublisherURL=http://gwyddion.net/
AppCopyright=Copyright (C) 2003-2005 David Necas (Yeti), Petr Klapetek
DefaultDirName={pf}\Gwyddion
DefaultGroupName=Gwyddion
DisableStartupPrompt=yes
WindowShowCaption=yes
WindowVisible=no
LicenseFile=COPYING.wri
Compression=bzip/9
SourceDir=.
; this means inst too
OutputDir=.
OutputBaseFilename=Gwyddion-1.12
ChangesAssociations=yes

[Files]
Source: "*.dll"; DestDir: "{app}"
Source: "*.wri"; DestDir: "{app}"
Source: "gwyddion.exe"; DestDir: "{app}"
Source: "pixmaps\*.*"; DestDir: "{app}\pixmaps"
Source: "modules\*.*"; DestDir: "{app}\modules"
Source: "modules\file\*.*"; DestDir: "{app}\modules\file"
Source: "modules\graph\*.*"; DestDir: "{app}\modules\graph"
Source: "modules\layer\*.*"; DestDir: "{app}\modules\layer"
Source: "modules\process\*.*"; DestDir: "{app}\modules\process"
Source: "modules\tool\*.*"; DestDir: "{app}\modules\tool"
Source: "plugins\file\*.*"; DestDir: "{app}\plugins\file"
Source: "locale\cs\LC_MESSAGES\*.*"; DestDir: "{app}\locale\cs\LC_MESSAGES"
Source: "locale\it\LC_MESSAGES\*.*"; DestDir: "{app}\locale\it\LC_MESSAGES"

[Icons]
Name: "{group}\Gwyddion"; Filename: "{app}\gwyddion.exe"; IconFilename: "{app}\pixmaps\gwyddion.ico"
Name: "{group}\Gwyddion Website"; Filename: "http://gwyddion.net/"
Name: "{group}\Uninstall Gwyddion"; Filename: "{uninstallexe}"
Name: "{userdesktop}\Gwyddion"; Filename: "{app}\gwyddion.exe"; IconFilename: "{app}\pixmaps\gwyddion.ico"

[Registry]
; Add Gtk+ libraries to gwyddion.exe's path
Root: HKLM; Subkey: "Software\Microsoft\Windows\CurrentVersion\App Paths\gwyddion.exe"; Flags: uninsdeletekeyifempty
Root: HKLM; Subkey: "Software\Microsoft\Windows\CurrentVersion\App Paths\gwyddion.exe"; ValueType: string; ValueData: "{app}\gwyddion.exe"; Flags: uninsdeletevalue
Root: HKLM; Subkey: "Software\Microsoft\Windows\CurrentVersion\App Paths\gwyddion.exe"; ValueType: string; ValueName: "Path"; ValueData: "{app};{code:GetGtkPath}\lib;{code:GetGtkPath}\bin"; Flags: uninsdeletevalue
; Add GtkGLExt libraries to gwyddion.exe's path
Root: HKLM; Subkey: "Software\Microsoft\Windows\CurrentVersion\App Paths\gwyddion.exe"; Flags: uninsdeletekeyifempty
Root: HKLM; Subkey: "Software\Microsoft\Windows\CurrentVersion\App Paths\gwyddion.exe"; ValueType: string; ValueData: "{app}\gwyddion.exe"; Flags: uninsdeletevalue
Root: HKLM; Subkey: "Software\Microsoft\Windows\CurrentVersion\App Paths\gwyddion.exe"; ValueType: string; ValueName: "Path"; ValueData: "{app};{code:GetGtkGLExtPath}\lib;{code:GetGtkGLExtPath}\bin"; Flags: uninsdeletevalue
; Add Gwyddion paths to the registry
Root: HKLM; Subkey: "Software\Gwyddion"; Flags: uninsdeletekeyifempty
Root: HKLM; Subkey: "Software\Gwyddion\1.0"; Flags: uninsdeletekey
Root: HKLM; Subkey: "Software\Gwyddion\1.0"; ValueType: string; ValueName: "Path"; ValueData: "{app}"; Flags: uninsdeletekey
Root: HKLM; Subkey: "Software\Gwyddion\1.0"; ValueType: string; ValueName: "Version"; ValueData: "1.12"; Flags: uninsdeletekey
Root: HKCU; Subkey: "Software\Gwyddion"; Flags: uninsdeletekeyifempty
Root: HKCU; Subkey: "Software\Gwyddion\1.0"; Flags: uninsdeletekey
Root: HKCU; Subkey: "Software\Gwyddion\1.0"; ValueType: string; ValueName: "Path"; ValueData: "{app}"; Flags: uninsdeletekey
Root: HKCU; Subkey: "Software\Gwyddion\1.0"; ValueType: string; ValueName: "Version"; ValueData: "1.12"; Flags: uninsdeletekey
; File associations
Root: HKCR; Subkey: ".gwy"; ValueType: string; ValueName: ""; ValueData: "Gwyddion.NativeData"; Flags: uninsdeletevalue
Root: HKCR; Subkey: "Gwyddion.NativeData"; ValueType: string; ValueName: ""; ValueData: "Gwyddion Native Data File"; Flags: uninsdeletekey
Root: HKCR; Subkey: "Gwyddion.NativeData\DefaultIcon"; ValueType: string; ValueName: ""; ValueData: "{app}\pixmaps\gwyddion.ico"
Root: HKCR; Subkey: "Gwyddion.NativeData\shell\open\command"; ValueType: string; ValueName: ""; ValueData: """{app}\gwyddion.exe"" ""%1"""


[Code]
var
  Exists: Boolean;
  GtkPath: String;
  GtkGLExtPath: String;

function GetGtkInstalled (): Boolean;
begin
  Exists := RegQueryStringValue (HKLM, 'Software\GTK\2.0', 'Path', GtkPath);
  if not Exists then begin
    Exists := RegQueryStringValue (HKCU, 'Software\GTK\2.0', 'Path', GtkPath);
  end;
  Result := Exists
end;

function GetGtkPath (S: String): String;
begin
    Result := GtkPath;
end;

function GetGtkGLExtInstalled (): Boolean;
begin
  Exists := RegQueryStringValue (HKLM, 'Software\GtkGLExt\1.0\Runtime', 'Path', GtkGLExtPath);
  if not Exists then begin
    Exists := RegQueryStringValue (HKCU, 'Software\GtkGLExt\1.0\Runtime', 'Path', GtkGLExtPath);
  end;
  if not Exists then begin
    GtkGLExtPath := GtkPath;
  end;
  Result := True;
end;

function GetGtkGLExtPath (S: String): String;
begin
    Result := GtkGLExtPath;
end;

function InitializeSetup(): Boolean;
begin
  Result := GetGtkInstalled ();
  if not Result then begin
    MsgBox ('Please install the Gtk+ 2.2 (or newer) Runtime Environment before installing Gwyddion.  You can obtain GTK+ from http://www.gimp.org/~tml/gimp/win32/.', mbError, MB_OK);
  end else begin
    Result := GetGtkGLextInstalled ();
    if not Result then begin
      MsgBox ('Please install the GtkGLExt+ 1.0 (or newer) before installing Gwyddion.  You can obtain GtkGLExt from http://gtkglext.sourceforge.net/.', mbError, MB_OK);
    end;
  end;
end;

